︠f8cfd23d-323e-42cb-a36a-3d36aa93436ai︠
%html
<p><span style="font-size: x-large;"><strong>Aufgabe 1: </strong>Banzhaf-Index</span></p>

︡6f966046-9008-4401-ad66-055153734125︡{"html": "<p><span style=\"font-size: x-large;\"><strong>Aufgabe 1: </strong>Banzhaf-Index</span></p>"}︡
︠f277b793-464b-40c9-956f-1fddda9a09a4︠
from itertools import imap
︡dfd517a9-845a-49ef-b262-d6eb4698f472︡︡
︠1c3f6822-ef38-448e-bbee-8ddf5d2452f5︠
def banzhaf(quotum, weight, other_weights):
    return sum(1 for s in imap(sum, powerset(other_weights))
                  if s < quotum and quotum <= s + weight)
︡7caafdab-2ab5-4468-a5ce-44d637f5190b︡︡
︠94549081-137e-43fe-a18d-18c225883208i︠
%html
<p><span style="font-size: large;">Absoluter Banzhaf-Index</span></p>

︡01faac68-3f3b-4507-a696-6846c0face8e︡{"html": "<p><span style=\"font-size: large;\">Absoluter Banzhaf-Index</span></p>"}︡
︠8db9ad54-25fb-42be-80ec-e75c31c76429︠
def abs_banzhafs(quotum, *weights):
    return vector(banzhaf(quotum, w, weights[:i]+weights[i+1:]) for i, w in enumerate(weights))
︡a8c3bd40-c17e-4057-a855-b60ffebc869e︡︡
︠a533eeaa-257f-4f74-817b-617acf17863fi︠
%html
<p><span style="font-size: large;">Relativer Banzhaf-Index</span></p>

︡bb7ef445-3fe7-4c45-a2d1-c1af4a065495︡{"html": "<p><span style=\"font-size: large;\">Relativer Banzhaf-Index</span></p>"}︡
︠24fd157f-0846-4004-9c26-fba2508369fc︠
def rel_banzhafs(quotum, *weights):
    abs_indices = abs_banzhafs(quotum, *weights)
    return abs_indices / sum(abs_indices)
︡8067f876-e8cc-46c4-a3bb-8b3c9c7822fc︡︡
︠fc1af25f-729d-4cb3-b91f-099d36dd1f84i︠
%html
<p><strong><span style="font-size: large;">Bundestag</span></strong></p>

︡7aa0e421-779c-49c1-888b-9e07f9efa3b7︡{"html": "<p><strong><span style=\"font-size: large;\">Bundestag</span></strong></p>"}︡
︠ffbed52f-2ec2-4c33-8461-240893124007︠
bt_stimmgewichte = (239, 146, 93, 76, 68)
︡b28ab4b2-ab60-4ce7-aeb4-4b1e40a7b114︡︡
︠b680723e-6422-46c8-ab25-ca3c913d7930︠
abs_banzhafs(312, *bt_stimmgewichte)
︡6518e114-98b0-4fac-8a06-4241df7ca9b1︡{"stdout": "(12, 4, 4, 4, 0)"}︡
︠37d85cbf-a64a-494e-88ba-5c9732b9058b︠
abs_banzhafs(415, *bt_stimmgewichte)
︡3df67344-6a7e-41af-bfa6-341bca9f5909︡{"stdout": "(8, 6, 2, 2, 2)"}︡
︠27f849bb-0184-4019-8033-4d7626e84069i︠
%html
<p><span style="font-size: large;"><strong>Norderweiterung</strong></span></p>

︡0ce2f606-e6bc-41d2-86fd-d5a1a025654e︡{"html": "<p><span style=\"font-size: large;\"><strong>Norderweiterung</strong></span></p>"}︡
︠1a92bd5d-ff85-4670-b2b6-1f002f684096︠
eu_stimmgewichte_v, qv = (4,   4,  4,  0, 2, 2, 0, 0, 1), 10
eu_stimmgewichte_n, qn = (10, 10, 10, 10, 5, 5, 3, 3, 2), 41
︡d1d15ba5-52e7-4330-a8e9-c8d62e21dc97︡︡
︠c79e6253-d1eb-4d81-be42-8df4b06062cc︠
rel_banzhafs(qv, *eu_stimmgewichte_v)
︡ee636fe4-eba2-4a81-b3a4-35c1be46dc76︡{"stdout": "(7/27, 7/27, 7/27, 0, 1/9, 1/9, 0, 0, 0)"}︡
︠869bfe64-7288-4528-9c4b-ef700b8b07ea︠
rel_banzhafs(qn, *eu_stimmgewichte_n)
︡c2c59166-c261-4f93-b789-974797b5b3fc︡{"stdout": "(53/317, 53/317, 53/317, 53/317, 29/317, 29/317, 21/317, 21/317, 5/317)"}︡
